if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::RTBR_ServerControl_Hook) exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
	RTB_registerPref("Players can save checkpoints?","Save Checkpoint Mod","$SaveCheck::AllowSave","bool","Script_SaveCheckpoint",1,0,0,"checkmessage");
	RTB_addInfoTip("You can save your checkpoint to where you are standing by typing /savecheck.", "", "Save Checkpoint Mod");
	RTB_addInfoTip("You can clear your checkpoint by typing /nocheck.", "", "Save Checkpoint Mod");
	RTB_addInfoTip("You can toggle the SaveCheckpoint mod in RTB prefs.", "", "Save Checkpoint Mod");
}

function checkmessage(%old, %new)
{
	if($SaveCheck::AllowSave)
	{
	schedule(10, 0, "messageall", "", "\c3+ Save Checkpoint Mod: \c0Players can now save their checkpoints.");
	}
	if(!$SaveCheck::AllowSave)
	{
	schedule(10, 0, "messageall", "", "\c3+ Save Checkpoint Mod: \c0Players can no longer save their checkpoints.");
	}
}

package SaveCheck
{
   function gameconnection::OnClientEnterGame(%this,%obj,%a,%b,%c,%d,%e)
	{
		%this.hasspawned = 1;
		Parent::OnClientEnterGame(%this,%a,%b,%c,%d,%e);
	}
   function GameConnection::SpawnPlayer(%client)
	{
	   Parent::SpawnPlayer(%client);
	   if($SaveCheck::AllowSave)
	   {
         if(%client.hascheck == 1)
         {
            %client.player.Position = %client.checkPosition;
         }
	   }
	}
	function servercmdSaveCheck(%client)
	{
	   if($SaveCheck::AllowSave)
	   {
	      if(%client.hasspawned == 1)
	      {
            %client.checkPosition = %client.player.Position;
            messageClient(%client,'','\c3Your checkpoint has been saved to where you are now.');
            %client.hascheck = 1;
	      }
	      else
	      {
	         messageClient(%client,'','\c0Wait until you spawn before using this.');
	      }
	   }
	   else
	   {
	      messageClient(%client,'','\c0This has been disabled.');
	      return;
	   }
	}
	function servercmdNoCheck(%client)
	{
	   if(%client.hascheck == 1)
	   {
	      %client.hascheck = 0;
	      messageClient(%client,'','\c3Your checkpoint has been cleared.');
	   }
	}
};
activatepackage(SaveCheck);